#ifndef _DLDATARUNS_H_
#define _DLDATARUNS_H_

/**
 * \brief Stores pixel run information.
 *
 * Information about pixels runs (connected rows of dark pixels in a binary image)
 * is available as publicly accessible members of this object.
 * Containers of DLDatarun objects can be used to 
 * store the runs of a binary image, and are used in DLComponent.
 */
class DLDatarun
{
   public:
   /**
    *  DLDatarun  Constructor
    */
   DLDatarun(){};
   /**
    *  DLDatarun Copy  Constructor
    */
   DLDatarun(const DLDatarun & orig){*this = orig;};

   /**
    *  Assignment operator
    * \param right DLDatarun 
    */
   const DLDatarun & operator=(const DLDatarun & right)
      {
         this->run_row = right.run_row;
         this->run_start = right.run_start;
         this->run_stop = right.run_stop;
         return *this;
      };

   /**
    *  DLDatarun  destructor
    */
   ~DLDatarun(){};
	
   public:
   ///row of run
   int run_row;                        
   ///first pixel of run
   int run_start;                      
   ///last+1 pixel of run
   int run_stop;                           
};

#endif // _DLDatarun_H_
