#ifndef _DLEDGEDETECT_H_
#define _DLEDGEDETECT_H_

#include "DLImage.h"

/** \cond **/
/**
 * \brief Image edge detection.
 *
 * The DLEdgeDetect class processes an DLImage object and determine its
 * edges.
 *
 * This functionality is not yet implemented.
 */
class DLEdgeDetect
{
   public:
   /**
    * Default DLEdgeDetect Constructor
    */
   DLEdgeDetect();
   /**
    *  Copy  Constructor
    * \param orig DLEdgeDetect
    */
   DLEdgeDetect(const DLEdgeDetect & orig){*this = orig;};

   /**
    *  Assignment operator
    * \param right DLEdgeDetect 
    */
   const DLEdgeDetect & operator=(const DLEdgeDetect & right){return *this;};
	

   /**
    * Default DLEdgeDetect Destructor
    */
   virtual ~DLEdgeDetect();

   /**
    * Detect edge 
    * \param image image to detect edges from
    * \return image of detected edges
    */
   DLImage dlDetectEdge(DLImage& image);

};//end class

/** \endcond **/
#endif //_DLEDGEDETECT_H_
