#ifndef _DLErode_H_
#define _DLErode_H_

#include "DLImage.h"
#include "DLPoint.h"
#include "DLBitsPerPixelConverter.h"

#include <cmath>

/**
 * \brief Erode an image.
 */
class DLErode
{
   public:
   /** \cond **/
   /**
    * Default DLErode Constructor
    */
   DLErode();

   /**
    * Default DLErode Destructor
    */
   virtual ~DLErode();
   /** \endcond **/

   /** 
    * Erode an image.
    *
    * This function operates only on binary (B&W) images.
    * At each application of the erode operation, a black pixel
    * is made white if any of its neighbors in the four principal
    * directions is white.
    * \param image binary DLImage to erode
    * \param numberOfTimes number of times to apply erode operation
    * \return eroded image
    */	
   static DLImage dlErode ( const DLImage & image, int numberOfTimes );
	
   private:
   static DLImage dlErodeBinary ( const DLImage & image, int numberOfTimes );
   static DLImage dlErodeGray ( const DLImage & image, int numberOfTimes );

};//end class

#endif //_DLErode_H_
