#ifndef DLVERSIONS_H
#define DLVERSIONS_H

#include "png.h"
#include "jpeglib.h"
#include "tiffvers.h"
#include "zlib.h"
#include <iostream>
#include <string>
#include <sstream>

/**
 * This file stores the current version of DOCLIB.
 */

/// Current version of DOCLIB
const static  char DL_VERSION[] =  "DOCLIB Beta 1.0 - $Name:  $";

/// Current versions of libraries DOCLIB depends on
const static int  DL_JPG_VERSION   = JPEG_LIB_VERSION;
const static char DL_TIF_VERSION[] = TIFFLIB_VERSION_STR;
const static char DL_PNG_VERSION[] = PNG_LIBPNG_VER_STRING;
const static char DL_Z_VERSION[]   = ZLIB_VERSION;

/**
 * \brief The DLVersions class is home to the static method dlPrintAllVersionInfo() 
 * that can be used to print out all available version information
 */

class DLVersions
{
   private:
   protected:
   public:

   /**
    * Print out all available version infomation for DOCLIB and the libraries
    * on which it depends
    */
   static void dlPrintAllVersionInfo() {
      /*    cout << endl;
            cout << "Version Information" << endl;
            cout << "DOCLIB:\t" << DL_VERSION << endl;
            cout << "\nLIBTIF:\t" << DL_TIF_VERSION << endl;
            cout << "\nLIBJPG:\t" << DL_JPG_VERSION << endl 
            << JCOPYRIGHT << endl;
            cout << "\nLIBPNG:\t" << DL_PNG_VERSION << endl;
            cout << "\nZLIB:\t" << DL_Z_VERSION << endl;
            cout << endl; */
      cout << dlGetAllVersionInfo();
   }

   /**
    * Get all available version infomation for DOCLIB and the libraries
    * on which it depends
    * \return string version-info
    */
   static string dlGetAllVersionInfo() {
      string jpgVersion;
      stringstream out;
      out << DL_JPG_VERSION;

      jpgVersion = out.str();

      string versionInfo = "";

      versionInfo = versionInfo + "\nVersion Information";
      versionInfo = versionInfo + "\nDOCLIB:\t" + DL_VERSION + "\n";
      versionInfo = versionInfo + "\nLIBTIF:\t" + DL_TIF_VERSION + "\n";
      versionInfo = versionInfo + "\nLIBJPG:\t" + jpgVersion + "\n";
      versionInfo = versionInfo + "\nLIBPNG:\t" + DL_PNG_VERSION + "\n";
      versionInfo = versionInfo + "\nZLIB:\t" + DL_Z_VERSION + "\n";

      return versionInfo;
   }

};

#endif // DLVERSIONS_H
