#ifndef COMMANDLINE_PARSER
#define COMMANDLINE_PARSER

#include "DLImage.h"
#include "DLShape.h"


#include <string>
#include <list>
using namespace std;

class DLCommandLineParser 
{
public:

    DLCommandLineParser();
    //void processCommand(char *argv[], int paramCount);
    void processCommand(list <string> cmdVector );
    //void processCommand(String cmd);


    bool dlCommandLinePolar(list <string> &cmds);
	bool dlCommandLineCartesian(list <string> &cmds);
    bool dlCommandLineResize(list <string> &cmds);
    bool dlCommandLineOutput(list <string> &cmds);
    bool dlCommandLineRotate(list <string> &cmds);
    bool dlCommandLineSubImage(list <string> &cmds);
    bool dlCommandLineNormalize(list <string> &cmds);
    bool dlCommandLineFlip(list <string> &cmds);
    bool dlCommandLineContour(list <string> &cmds);
    bool dlCommandLineReverse(list <string> &cmds);
    bool dlCommandLinePaste(list <string> &cmds);
    bool dlCommandLineAddImage(list <string> &cmds) ;
    
    bool dlCommandLineProject(list <string> &cmds);
    bool dlCommandLineConvert(list <string> &cmds);
    bool dlCommandLineSetPixel(list <string> &cmds);
    bool dlCommandLineBoundCC(list <string> &cmds);
    bool dlCommandLineFilterCC(list <string> &cmds);
    bool dlCommandLineFilterCCDensityLess(list <string> &cmds);
    bool dlCommandLineFilterCCDensityGreater(list <string> &cmds);

    bool dlCommandLineDrawLine(list <string> &cmds);
    bool dlCommandLineDrawBox(list <string> &cmds);

    bool dlCommandLineDilate(list <string> &cmds);
    bool dlCommandLineErode(list <string> &cmds);
    bool dlCommandLineSharpen(list <string> &cmds);
    bool dlCommandLineBlur(list <string> &cmds);
    bool dlCommandLineGaussianBlur(list <string> &cmds);
    bool dlCommandLineToYCrCb(list <string> &cmds);

    bool dlCommandLineYCrCbBinarization(list <string> &cmds);
    bool dlDownscale256Color_global(list <string> &cmds);
    bool dlCommandLinePercentThresholdBinarization(list <string> &cmds);
    bool dlCommandLineThresholdBinarization(list <string> &cmds);
    bool dlCommandLineColor2Gray_global(list <string> &cmds);
    bool dlCommandLineGray2Binary_global(list <string> &cmds);
    bool dlCommandLineNiBlackBinarization(list <string> &cmds);
    bool dlCommandLineBinary2Color(list <string> &cmds);
    bool dlCommandLineGray2Color(list <string> &cmds);
    bool dlCommandLineBinary2Gray(list <string> &cmds);
    bool dlCommandLineSkeletonize(list <string>& cmds);
    bool dlCommandLineDeskew(list <string>& cmds);
    bool dlOpenFile(list <string> &cmds);
    bool dlLoadDocFile(list <string>& cmds);

    bool dlCommandLineCentroid ( list <string> &cmds);
    bool dlCommandLineDebugSwitch( list <string> &cmds);
    bool dlImageInfo(list <string> &cmds);
    bool dlCommandLineVersionInfo(list <string> &cmds);


private:
    DLImage image;
    bool loadImageAsMemory;
    //string h;
public:
    int (*fp)(list <string> &cmds);

};




#endif
